#pragma once
#include "esptool.h"	// word, uint32
#include "intrin.h"

namespace esp{

enum Chipmagic{	// Chip-ID von ROM?-Adresse 0x40001000
 ESP8266	= 0xFFF0C101,
 ESP32		= 0x00F01D83,
 undefined	= 0xDEADBEEF,
// Andere Chips sind alles auer diese beiden
};

struct Info1{
 char name[7];
 char image_chip_id;
 uint32 magic;	// Bis zu 4 IDs bei ESP32S2
};

struct Info2{
 char image_chip_id;
 uint16 hi_irom_map_start,hi_irom_map_end,hi_drom_map_start,hi_drom_map_end;
 uint32 spi_reg_base,efuse_rd_reg_base;
};

const Info1*find1(Chipmagic chip);	// nullptr wenn nicht gefunden
const Info1*find1(char image_id);
const Info1*find1(const char*chip);
const Info2*find2(char image_id);
const byte*stub(char image_id);

enum{
 XOR8_INIT   = 0xEF,	// Initial state for the checksum routine
};
byte xor8(const void*data, int dlen, byte state=XOR8_INIT);

String<80>memareas(char image_id,unsigned A, unsigned E);
}// namespace esp
